(define (domain slide-puzzle)

    (:requirements
        :typing
    )

    (:types
        tile
        number
    )

    (:predicates
        (at ?n - number ?t - tile)
        (clear ?t - tile)
        (next ?t1 - tile ?t2 - tile)
    )

    (:action slide
        :parameters (?n - number ?t1 - tile ?t2 - tile)
        :precondition (and 
            (at ?n ?t1)
            (clear ?t2)
            (next ?t1 ?t2)
        )
        :effect (and 
            (not (at ?n ?t1))
            (clear ?t1)
            (not (clear ?t2)) 
            (at ?n ?t2)
        )
    )
)